dhtmlxScheduler с Svelte

Это руководство предполагает, что вы знакомы с основными концепциями и паттернами Svelte. Если нет, ознакомьтесь с документацией Svelte, где есть полезный вводный туториал.

DHTMLX Scheduler хорошо работает с Svelte. Вы можете посмотреть рабочий пример на GitHub: DHTMLX Scheduler with Svelte Demo.

Создание проекта

Перед созданием нового проекта убедитесь, что у вас установлены Vite (необязательно) и Node.js.

Чтобы создать проект Svelte с помощью Vite, выполните команду:

npm create vite@latest

Подробнее смотрите в соответствующей статье.

Установка зависимостей

Далее перейдите в директорию вашего приложения. Назовём проект scheduler-svelte и выберите опцию svelte. Затем выполните:

cd scheduler-svelte

После этого установите зависимости и запустите приложение с помощью вашего менеджера пакетов:

  • Для yarn выполните:
yarn install
yarn dev
  • Для npm выполните:
npm install
npm run dev

Теперь ваш проект Svelte должен быть доступен по адресу http://localhost:5173.

Scheduler Svelte app running

Создание Gantt

Чтобы добавить DHTMLX Scheduler, сначала остановите приложение, нажав Ctrl+C в терминале. Затем установите пакет Scheduler.

Шаг 1. Установка пакета

PRO-версии библиотеки доступны через npm/yarn из нашего приватного репозитория. Следуйте этой инструкции для получения доступа.

После получения Evaluation-версии установите её с помощью:

  • npm:
npm install @dhx/trial-scheduler
  • yarn:
yarn add @dhx/trial-scheduler

Кроме того, так как zip-пакет библиотеки структурирован как модуль npm, вы можете установить его из локальной папки.

Шаг 2. Создание компонента

Создайте новый компонент Svelte для добавления Scheduler в ваше приложение. В директории src/ создайте файл Scheduler.svelte.

Импорт исходных файлов

Откройте Scheduler.svelte и импортируйте файлы Scheduler. В зависимости от способа установки:

  • Если установлен из локальной папки, импорты будут такими:

Scheduler.svelte

import { Scheduler } from "dhtmlx-scheduler";
import "dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
  • Если используется trial-версия, импорты должны быть такими:

Scheduler.svelte

import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";

В этом руководстве используется trial-версия.

Задание контейнера и добавление Scheduler

Чтобы отобразить Scheduler, определите элемент-контейнер, в котором он будет отображаться. Пример кода ниже:

Scheduler.svelte

<script>
    import { onMount } from "svelte";
    import { Scheduler } from "@dhx/trial-scheduler";
    import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
    let scheduler;
    let container;
    onMount(() => {
        scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace";
        scheduler.init(container, new Date(2023, 9, 6), "week");
 
        return () => scheduler.destructor();
    });
</script>   <div bind:this={container} style="width: 100%; height: 100vh;"></div>

Чтобы контейнер Scheduler занимал всю область body, удалите стандартные стили из app.css в src/ и добавьте:

src/app.css

body {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

Шаг 3. Добавление Scheduler в приложение

Далее подключите компонент Scheduler в ваше приложение. Откройте src/App.svelte и замените содержимое на:

App.svelte

<script>
  import Scheduler from "./Scheduler.svelte";
</script>   <Scheduler/>

После запуска приложения на странице должен появиться пустой Scheduler:

Scheduler Svelte init

Шаг 4. Добавление данных

Чтобы отобразить события, передайте данные в Scheduler. Создайте файл data.js в src/ и добавьте пример данных:

src/data.js

export function getData() {
    const data = [
        {
            start_date: "2024-06-10 6:00",
            end_date: "2024-06-10 8:00",
            text: "Event 1",
            id: 1,
        },
        {
            start_date: "2024-06-13 10:00",
            end_date: "2024-06-13 18:00",
            text: "Event 2",
            id: 2,
        },
    ];
    return data;
}

Затем передайте эти данные как prop в компонент Scheduler в App.svelte:

App.svelte

<script>
  import Scheduler from "./Scheduler.svelte";
  import { getData } from "./data.js";
</script>   <Scheduler data={getData()} />

Внутри Scheduler.svelte используйте prop с помощью scheduler.parse():

Scheduler.svelte

<script>
    import { onMount } from "svelte";
 
    import { Scheduler } from "@dhx/trial-scheduler";
    import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css"
    export let data;  
    let scheduler;
    let container;
    onMount(() => {
        scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace"
        scheduler.init(container, new Date(2024, 5, 10), "week");
 
        return () => scheduler.destructor();
    });
 
    $: scheduler?.parse(data);
</script>   <div bind:this={container} style="width: 100%; height: 100vh;"></div>

После перезагрузки приложения Scheduler будет заполнен событиями:

Scheduler Svelte events

Шаг 5. Сохранение данных

Чтобы обрабатывать изменения, сделанные в Scheduler, используйте обработчик dataProcessor, который обеспечивает связь с сервером. Обработчик может быть функцией или объектом router. dhtmlxScheduler поддерживает ответы в виде Promise, поэтому он корректно ожидает завершения действий.

Создайте DataProcessor с помощью createDataProcessor() и обрабатывайте изменения так:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

Если ваш backend изменяет идентификаторы событий при создании новых записей (что часто бывает), убедитесь, что ваш Promise возвращает объект с {id: databaseId} или {tid: databaseId}, чтобы Scheduler мог обновить событие. Подробнее смотрите в разделе интеграция с сервером.

На этом настройка Svelte Scheduler завершена. Вы можете ознакомиться с полной демо-версией на GitHub: svelte-scheduler-demo.

XSS, CSRF и SQL Injection атаки

Обратите внимание, что Scheduler сам по себе не защищает от угроз, таких как SQL-инъекции, XSS или CSRF-атаки. Защита приложения лежит на ответственности backend-разработчиков.

Ознакомьтесь со статьёй Безопасность приложения, чтобы узнать о потенциальных уязвимостях компонента и рекомендуемых мерах безопасности.

Наверх

dhtmlxScheduler с Angular

Данное руководство предполагает, что вы обладаете базовыми знаниями концепций и паттернов Angular. Если это не так, рекомендуем ознакомиться с документацией Angular и пройти обучающий курс для начинающих.

DHTMLX Scheduler отлично работает с Angular. Практический пример можно найти на GitHub: DHTMLX Scheduler with Angular Demo.

Создание проекта

Перед началом убедитесь, что у вас установлены Angular CLI и Node.js. Затем выполните команду:

ng new my-angular-scheduler-app

Эта команда подготовит все необходимые инструменты и зависимости, никаких дополнительных шагов не потребуется.

Установка зависимостей

Далее перейдите в папку приложения:

cd my-angular-scheduler-app

Запустите приложение одной из следующих команд:

yarn start

или

npm start

Теперь приложение будет доступно по адресу http://localhost:4200.

Scheduler with Angular

Создание Scheduler

Чтобы добавить DHTMLX Scheduler, сначала остановите запущенное приложение, нажав Ctrl+C в терминале. Затем установите пакет Scheduler.

Шаг 1. Установка пакета

PRO-версии библиотеки доступны через npm/yarn из нашего приватного репозитория. Следуйте этой инструкции, чтобы получить доступ.

После получения Evaluation-версии установите её с помощью:

  • npm:
npm install @dhx/trial-scheduler
  • yarn:
yarn add @dhx/trial-scheduler

Также, поскольку zip-пакет библиотеки структурирован как модуль npm, вы можете установить его из локальной папки.

Шаг 2. Создание компонента

Создайте новый компонент для интеграции Scheduler. Внутри директории src/app/ создайте папку scheduler и добавьте в неё файлы: scheduler.component.ts, scheduler.component.css и scheduler.component.html.

В scheduler.component.html добавьте следующий шаблон для Scheduler:

scheduler/scheduler.component.html

<div #scheduler_here class="dhx_cal_container" style="width: 100%; height:100vh">
   <div class="dhx_cal_navline">
       <div class="dhx_cal_prev_button"></div>
       <div class="dhx_cal_next_button"></div>
       <div class="dhx_cal_today_button"></div>
       <div class="dhx_cal_date"></div>
       <div class="dhx_cal_tab" data-tab="day"></div>
       <div class="dhx_cal_tab" data-tab="week"></div>
       <div class="dhx_cal_tab" data-tab="month"></div>
   </div>
   <div class="dhx_cal_header"></div>
   <div class="dhx_cal_data"></div>
</div>

Стили для Scheduler объявите отдельно в scheduler.component.css. Пример базовых стилей:

scheduler/scheduler.component.css

@import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
:host {
   display: block;
   position: relative;
   height: 100%;
   width: 100%;
}

Чтобы контейнер Scheduler занимал всю область body, добавьте эти стили в styles.css в папке src:

src/styles.css

html,
body {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

Импорт исходных файлов

Откройте scheduler.component.ts и scheduler.component.css для импорта исходных файлов Scheduler. В зависимости от способа установки:

  • Если установлен из локальной папки, импорты выглядят так:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from 'dhtmlx-scheduler';

scheduler.component.css

@import "@dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
  • Если используется trial-версия, импорты должны быть следующими:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from '@dhx/trial-scheduler';

scheduler.component.css

@import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";

В данном руководстве используется trial-версия.

Указание контейнера и добавление Scheduler

Чтобы отобразить Scheduler на странице, необходимо указать контейнер для его рендера. Пример кода:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from "@dhx/trial-scheduler";
import { Component, ElementRef, OnInit, OnDestroy, 
    ViewChild, ViewEncapsulation } from "@angular/core";
 
@Component({
  encapsulation: ViewEncapsulation.None,
  selector: "scheduler",
  styleUrls: ["./scheduler.component.css"],
  templateUrl: 'scheduler.component.html'
})
 
export class SchedulerComponent implements OnInit, OnDestroy {
  @ViewChild("scheduler_here", { static: true }) schedulerContainer!: ElementRef;
  private _scheduler?: SchedulerStatic;
 
  ngOnInit() {
    let scheduler = Scheduler.getSchedulerInstance();
    scheduler.init(
      this.schedulerContainer.nativeElement,
      new Date(2024, 9, 7),
      "week", 
    );
    this._scheduler = scheduler;
  }
 
  ngOnDestroy() {
    if (this._scheduler) this._scheduler.destructor();
  }
}

Здесь хук жизненного цикла ngOnInit() инициализирует Scheduler, а ngOnDestroy() вызывает scheduler.destructor() для очистки при уничтожении компонента.

Шаг 3. Добавление Scheduler в приложение

Далее замените содержимое по умолчанию на компонент Scheduler. Откройте src/app/app.component.ts и обновите его следующим образом:

src/app/app.component.ts

import { Component } from '@angular/core';
 
@Component({
  selector: 'app-root',
  template: `<scheduler></scheduler>`,
})
export class AppComponent {
  name = '';
}

Создайте app.module.ts в src/app/ и подключите SchedulerComponent следующим образом:

src/app/app.module.ts

import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
 
import { AppComponent } from "./app.component";
import { SchedulerComponent } from "./scheduler/scheduler.component";
 
@NgModule({
  declarations: [AppComponent, SchedulerComponent],
  imports: [BrowserModule],
  providers: [],
  bootstrap: [AppComponent],
})
export class AppModule {}

Наконец, обновите src/main.ts, заменив его содержимое на:

src/main.ts

import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
 
platformBrowserDynamic()
  .bootstrapModule(AppModule)
  .catch((err) => console.error(err));

После повторного запуска приложения на странице появится пустой Scheduler.

Adding Scheduler into an app

Шаг 4. Подключение данных

Чтобы загрузка данных в Scheduler для Angular работала, необходимо добавить сервис для событий. Перед этим нужно определить модель события.

Для создания модели события используйте команду:

ng generate class models/event --skip-tests

В новом файле event.ts в папке models добавьте следующий код:

models/event.ts

export class Event {
    id!:  number;
    start_date!: string;
    end_date!: string;
    text!: string;
}

Далее создайте сервис событий. Это класс, который отвечает за управление определёнными событиями. В Angular сервисы могут внедряться с помощью Dependency Injection. Они могут содержать данные, функции или функциональность, необходимую приложению. Здесь будет создан сервис данных для передачи событий Scheduler.

Для генерации сервиса выполните:

ng generate service services/event --flat --skip-tests

В новом файле event.service.ts в папке services добавьте следующий код:

services/event.service.ts

import { Injectable } from '@angular/core';
import { Event } from "../models/event";
 
@Injectable()
export class EventService {
    get(): Promise<Event[]>{
        return Promise.resolve([
            { id: 1, start_date: "2023-05-16 09:00", end_date: "2023-05-16 13:00", 
                text: "Event 1" },
            { id: 2, start_date: "2023-05-18 10:00", end_date: "2023-05-18 14:00", 
                text: "Event 2" },
        ]);
    }
}

Декоратор @Injectable() помечает сервис как доступный для внедрения. В дальнейшем этот сервис будет внедрён в компонент.

В данный момент метод get() возвращает промис с жёстко заданными событиями. Также можно загружать данные с сервера и возвращать промис. Компонент Scheduler будет использовать EventService для получения событий. Для этого импортируйте EventService в scheduler.component.ts:

scheduler.component.ts

import {EventService} from "../services/event.service";

Затем укажите EventService как provider в декораторе @Component:

scheduler.component.ts

@Component({
  encapsulation: ViewEncapsulation.None,
  selector: "scheduler",
  providers: [EventService],
  styleUrls: ["./scheduler.component.css"],
  templateUrl: 'scheduler.component.html'
})

Это гарантирует, что для каждого SchedulerComponent будет создан новый экземпляр сервиса. Для внедрения сервиса в компонент добавьте следующий конструктор в класс SchedulerComponent:

scheduler.component.ts

constructor(private eventService: EventService){}

Обновите метод ngOnInit() чтобы:

  • задать формат даты для загрузки событий (здесь используется XML-формат)
  • вызвать сервис для получения событий и дождаться данных перед передачей их в Scheduler

scheduler.component.ts

scheduler.config.date_format = "%Y-%m-%d %H:%i";
scheduler.init(this.schedulerContainer.nativeElement, new Date(2024, 9, 7));
this.eventService.get()
    .then((data) => {
         scheduler.parse(data);
    });

Полный файл scheduler.component.ts будет выглядеть так:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from "@dhx/trial-scheduler";
import { Component, ElementRef, OnInit, OnDestroy, 
    ViewChild, ViewEncapsulation } from "@angular/core";
import {EventService} from "../services/event.service";
 
@Component({
  encapsulation: ViewEncapsulation.None,
  selector: "scheduler",
  providers: [EventService],
  styleUrls: ['scheduler.component.css'],
  templateUrl: 'scheduler.component.html'
})
 
export class SchedulerComponent implements OnInit, OnDestroy {
  @ViewChild("scheduler_here", { static: true }) schedulerContainer!: ElementRef;
  private _scheduler?: SchedulerStatic;
  constructor(private eventService: EventService) { }
 
  ngOnInit() {
    let scheduler = Scheduler.getSchedulerInstance();
    scheduler.config.date_format = "%Y-%m-%d %H:%i";
    scheduler.init(
      this.schedulerContainer.nativeElement,
      new Date(2024, 9, 7),
      "week", 
    );
    this.eventService.get().then((data) => {scheduler.parse(data);});
    this._scheduler = scheduler;
  }
 
  ngOnDestroy() {
    if (this._scheduler) this._scheduler.destructor();
  }
}

После перезагрузки страницы приложения Scheduler отобразит события.

Scheduler with Angular events

Шаг 5. Сохранение данных

Для отслеживания изменений, внесённых в Gantt, можно использовать обработчик dataProcessor для взаимодействия с серверной частью. Этот обработчик может быть определён как функция или объект router. dhtmlxScheduler поддерживает ответы от обработчика в виде Promise, что обеспечивает корректную обработку действий.

DataProcessor можно создать с помощью метода API createDataProcessor() для отслеживания изменений следующим образом:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

Если сервис изменяет идентификатор события после создания новой записи (что является распространённой практикой), Promise должен возвращать объект, содержащий {id: databaseId} или {tid: databaseId}. Это позволяет Scheduler обновить запись с новым идентификатором из базы данных.

Подробнее об интеграции с серверной частью читайте здесь.

Теперь Angular Scheduler настроен. Вы можете посмотреть полный демо-проект на GitHub.

XSS, CSRF и SQL-инъекции

Обратите внимание, что сам Scheduler не обеспечивает защиту от угроз, таких как SQL-инъекции, XSS или CSRF-атаки. Обеспечение безопасности приложения лежит на ответственности backend-разработчиков.

Больше информации о возможных уязвимостях и рекомендуемых мерах безопасности вы найдёте в статье Application Security.

Наверх

dhtmlxScheduler с Vue.js

Это руководство предполагает, что вы обладаете базовыми знаниями Vue и его паттернов. Если вам нужно освежить память, ознакомьтесь с документацией Vue 3, где есть полезный вводный туториал.

DHTMLX Scheduler отлично работает с Vue. Ознакомьтесь с соответствующим примером на GitHub: DHTMLX Scheduler with Vue Demo.

Создание проекта

Перед началом убедитесь, что у вас установлен Node.js.

Для создания проекта на Vue выполните команду:

npm create vue@latest

Эта команда установит и запустит create-vue — официальный инструмент для создания проектов на Vue. Подробнее можно узнать в быстром старте Vue.js.

Установка зависимостей

Далее перейдите в директорию приложения. В этом примере проект будет называться scheduler-vue:

cd scheduler-vue

Затем установите зависимости и запустите сервер разработки с помощью пакетного менеджера:

  • Для yarn выполните:
yarn install
yarn dev
  • Для npm выполните:
npm install
npm run dev

Теперь ваш проект на Vue будет доступен по адресу http://localhost:5173.

Scheduler Vue.js app running

Создание Scheduler

Перед добавлением Scheduler остановите запущенное приложение, нажав Ctrl+C в терминале. После этого установите пакет Scheduler.

Шаг 1. Установка пакета

PRO-версии библиотеки доступны через npm/yarn из нашего приватного репозитория. Следуйте этой инструкции, чтобы получить доступ.

После получения Evaluation-версии Scheduler установите её с помощью:

  • npm:
npm install @dhx/trial-scheduler
  • yarn:
yarn add @dhx/trial-scheduler

Также, поскольку zip-пакет библиотеки структурирован как модуль npm, вы можете установить его из локальной папки.

Шаг 2. Создание компонента

Создайте компонент Vue для интеграции Scheduler в ваше приложение. Добавьте новый файл Scheduler.vue в директорию src/components/.

Импорт исходных файлов

Откройте Scheduler.vue и импортируйте исходные файлы Scheduler. В зависимости от способа установки:

  • При установке из локальной папки импорты будут такими:

Scheduler.vue

import { Scheduler } from "dhtmlx-scheduler";<style>
  @import "@dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
</style>
  • Для trial-версии импорты должны быть следующими:

Scheduler.vue

import { Scheduler } from "@dhx/trial-scheduler";<style>
  @import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
</style>

В этом руководстве используется trial-версия Scheduler.

Задание контейнера и добавление Scheduler

Для отображения Scheduler на странице задайте элемент-контейнер. Пример кода:

Scheduler.vue

<script>
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default {
  mounted() {
    let scheduler = Scheduler.getSchedulerInstance();
    let date = scheduler.init(this.$refs.cont, new Date(2023, 9, 6), "week");
    this.scheduler = scheduler;
  },
  unmounted() {
    this.scheduler.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100vh"></div> </template>

Чтобы контейнер Scheduler занимал всю область body, удалите стандартные стили из main.css в папке src/assets и замените их на:

src/assets/main.css

#app {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

Шаг 3. Добавление Scheduler в приложение

Добавьте компонент Scheduler в приложение. Откройте src/App.vue и замените содержимое на:

src/App.vue

<script>
import Scheduler from "./components/Scheduler.vue";
 
export default {
  components: { Scheduler },
};
</script>   <template> <Scheduler/> </template>

После запуска приложения на странице появится пустой Scheduler:

Scheduler Vue init

Шаг 4. Передача данных

Чтобы отображать события в Scheduler, необходимо передать данные. Создайте файл data.js в директории src/ и добавьте туда пример событий:

src/data.js

export function getData() {
    const data = [
        {
            start_date: "2024-06-10 6:00",
            end_date: "2024-06-10 8:00",
            text: "Event 1",
            id: 1,
        },
        {
            start_date: "2024-06-13 10:00",
            end_date: "2024-06-13 18:00",
            text: "Event 2",
            id: 2,
        },
    ];
    return data;
}

Передайте эти данные как props в компонент Scheduler в App.vue:

App.vue

<script>
import Scheduler from "./components/Scheduler.vue";
import { getData } from "./data";
 
export default {
  components: { Scheduler },
  data() {
    return {
      events: getData(),
    };
  },
};
</script>   <template> <Scheduler :events="events" /> </template>

Далее используйте props в методе scheduler.parse() внутри компонента Scheduler:

Scheduler.vue

<script>
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default {
  props: ["events"],
  mounted() {
    let scheduler = Scheduler.getSchedulerInstance();
    let date = scheduler.init(this.$refs.cont, new Date(2023, 5, 10), "week");
    scheduler.parse(this.events);
 
    this.scheduler = scheduler;
  },
  unmounted() {
    this.scheduler.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100vh"></div> </template>

После перезагрузки страницы приложения Scheduler отобразит события:

Scheduler Vue events

Шаг 5. Сохранение данных

Для отслеживания изменений, внесённых в Scheduler, используйте обработчик dataProcessor, который обеспечивает взаимодействие с сервером. Обработчик может быть функцией или объектом-роутером. dhtmlxScheduler поддерживает ответы в виде Promise, что гарантирует корректную обработку завершения действий.

Создайте DataProcessor с помощью метода createDataProcessor() и отслеживайте изменения следующим образом:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

Если ваш backend изменяет id события после создания новой записи (что часто бывает), убедитесь, что ваш Promise возвращает объект с {id: databaseId} или {tid: databaseId}. Это позволит Scheduler обновить запись с новым id из базы данных. Подробнее см. в разделе интеграция с сервером.

На этом настройка Scheduler для Vue завершена. Ознакомьтесь с полной демонстрацией на GitHub: https://github.com/DHTMLX/vue-scheduler-demo.

XSS, CSRF и SQL Injection атаки

Обратите внимание, что сам Scheduler не обеспечивает защиту от угроз, таких как SQL-инъекции, XSS или CSRF-атаки. Безопасность приложения — это ответственность разработчиков, особенно при реализации backend.

Ознакомьтесь со статьёй Безопасность приложения, чтобы понять уязвимые места компонента и узнать, как повысить безопасность вашего приложения.

Наверх

dhtmlxScheduler с React

Это руководство предполагает, что вы знакомы с основами React и его концепциями. Если вы только начинаете работать с React, рекомендуем ознакомиться с официальной документацией.

DHTMLX Scheduler отлично работает с React. Пример интеграции можно найти на GitHub: DHTMLX Scheduler with React Demo.

Создание проекта

Перед началом убедитесь, что у вас установлен Node.js.

Для создания простого проекта на React выполните команду:

npx create-vite my-react-scheduler-app --template react

Установка зависимостей

Перейдите в директорию вашего приложения. В данном примере используется my-react-scheduler-app:

cd my-react-scheduler-app

Далее установите зависимости и запустите сервер разработки с помощью вашего пакетного менеджера:

  • Для yarn выполните:
yarn install
yarn dev
  • Для npm выполните:
npm install
npm run dev

Ваш React-проект будет доступен по адресу http://localhost:5173.

Scheduler React app running

Создание Scheduler

Чтобы добавить DHTMLX Scheduler, сначала остановите приложение, нажав Ctrl+C в командной строке. После этого установите пакет Scheduler.

Шаг 1. Установка пакета

PRO-версии библиотеки доступны через npm/yarn из нашего приватного репозитория. Пожалуйста, следуйте этой инструкции для получения доступа.

Когда у вас будет Evaluation-версия Scheduler, установите её одной из команд:

  • Через npm:
npm install @dhx/trial-scheduler
  • Через yarn:
yarn add @dhx/trial-scheduler

Также, так как zip-пакет библиотеки структурирован как npm-модуль, вы можете установить его из локальной папки.

Шаг 2. Создание компонента

Создайте React-компонент для добавления Scheduler в приложение. Создайте папку src/components/Scheduler и в ней файлы: Scheduler.jsx, Scheduler.css и index.js.

Начните с создания Scheduler.css со стилями для scheduler-container:

src/components/Scheduler/Scheduler.css

.scheduler-container {
    height: 100vh;
    width: 100vw;
}

Чтобы контейнер Scheduler занимал всю область body, удалите стандартные стили из App.css в папке src и добавьте:

#root {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

Добавьте файл index.js со следующим содержимым:

src/components/Scheduler/index.js

import Scheduler from './Scheduler';
import './Scheduler.css';
export default Scheduler;

Импорт исходных файлов

Откройте Scheduler.jsx и импортируйте исходные файлы Scheduler. В зависимости от способа установки пакета, импорты будут такими:

  • Если установлен из локальной папки:

Scheduler.jsx

import { Scheduler } from 'dhtmlx-scheduler';
import 'dhtmlx-scheduler/codebase/dhtmlxscheduler.css';
  • При использовании trial-версии:

Scheduler.jsx

import { Scheduler } from '@dhx/trial-scheduler';
import '@dhx/trial-scheduler/codebase/dhtmlxscheduler.css';

В данном руководстве используется trial-версия.

Настройка контейнера и добавление Scheduler

Чтобы отобразить Scheduler на странице, создайте контейнер. Создайте Scheduler.jsx со следующим кодом:

src/components/Scheduler/Scheduler.jsx

import { useEffect, useRef } from "react";
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default function SchedulerView( ) {
    let container = useRef();
    useEffect(() => {
        let scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace";
        scheduler.config.header = [
            "day",
            "week",
            "month",
            "date",
            "prev",
            "today",
            "next",
        ];
 
        scheduler.init(container.current, new Date(2024, 5, 10));
        return () => {
            scheduler.destructor();
            container.current.innerHTML = "";
        };
    }, []);
 
    return (
        <div ref={container} style=width: "100%", height: "100%"></div>
    );
}

Шаг 3. Добавление Scheduler в приложение

Теперь добавьте компонент Scheduler в приложение. Откройте src/App.jsx и замените содержимое на:

src/App.jsx

import Scheduler from "./components/Scheduler";
import "./App.css";
 
function App() {
    return (
        <div className="scheduler-container">
            <Scheduler/>
        </div>
    );
}
export default App;

После запуска приложения на странице появится пустой Scheduler:

Scheduler React init

Шаг 4. Передача данных

Чтобы отобразить события в Scheduler, передайте набор данных. Создайте файл data.js в директории src/ и добавьте события:

src/data.js

export function getData() {
    const data = [
        {
            start_date: "2024-06-10 6:00",
            end_date: "2024-06-10 8:00",
            text: "Event 1",
            id: 1,
        },
        {
            start_date: "2024-06-13 10:00",
            end_date: "2024-06-13 18:00",
            text: "Event 2",
            id: 2,
        },
    ];
    return data;
}

Передайте эти данные как props для компонента Scheduler в App.jsx:

App.jsx

import { getData } from "./data.js";
import Scheduler from "./components/Scheduler";
import "./App.css";
 
function App() {
    return (
        <div className="scheduler-container">
            <Scheduler events={getData()}/>
        </div>
    );
}
export default App;

Используйте props в методе scheduler.parse() внутри компонента Scheduler:

Scheduler.jsx

import { useEffect, useRef } from "react";
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default function SchedulerView({events}) {
    let container = useRef();
    useEffect(() => {
        let scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace";
        scheduler.config.header = [
            "day",
            "week",
            "month",
            "date",
            "prev",
            "today",
            "next",
        ];
 
        scheduler.init(container.current, new Date(2024, 5, 10));
        scheduler.parse(events);
        return () => {
            scheduler.destructor();
            container.current.innerHTML = "";
        };
    }, []);
 
    return (
        <div ref={container} style=width: "100%", height: "100%"></div>
    );
}

После перезагрузки страницы приложения вы увидите Scheduler с загруженными событиями:

Scheduler React events

Шаг 5. Сохранение данных

Чтобы обрабатывать изменения, внесённые в Scheduler, используйте обработчик dataProcessor. Это позволит связаться с сервером. Обработчик может быть функцией или объектом router. dhtmlxScheduler поддерживает ответы Promise от обработчика, корректно обрабатывая завершение действия.

Создайте DataProcessor с помощью createDataProcessor() и отслеживайте изменения следующим образом:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

Если ваш backend изменяет id события после создания новой записи (что встречается часто), убедитесь, что Promise возвращает объект с {id: databaseId} или {tid: databaseId}. Это позволит Scheduler обновить запись с новым id из базы данных. Подробнее см. в разделе server side integration.

На этом настройка React Scheduler завершена. Ознакомьтесь с полной демонстрацией на GitHub: DHTMLX react-scheduler-demo.

XSS, CSRF и SQL-инъекции

Обратите внимание, что сам Scheduler не защищает от угроз, таких как SQL-инъекции, XSS или CSRF-атаки. Ответственность за защиту приложения от этих рисков лежит на разработчиках backend.

Обратитесь к статье Application Security, чтобы узнать о распространённых уязвимостях и способах повышения безопасности вашего приложения.

Наверх